package org.wfc.omada.api.msp.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.Min;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * Gateway used license
 */
@ApiModel(description = "Gateway used license")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:44:08.065+08:00[Asia/Shanghai]")

public class LicenseCategoryOtherIdsOpenApiVo   {
  @JsonProperty("licenseKeyList")
  @Valid
  private List<String> licenseKeyList = null;

  @JsonProperty("selectAll")
  private Boolean selectAll;

  @JsonProperty("total")
  private Integer total;

  public LicenseCategoryOtherIdsOpenApiVo licenseKeyList(List<String> licenseKeyList) {
    this.licenseKeyList = licenseKeyList;
    return this;
  }

  public LicenseCategoryOtherIdsOpenApiVo addLicenseKeyListItem(String licenseKeyListItem) {
    if (this.licenseKeyList == null) {
      this.licenseKeyList = new ArrayList<>();
    }
    this.licenseKeyList.add(licenseKeyListItem);
    return this;
  }

  /**
   * License key list
   * @return licenseKeyList
  */
  @ApiModelProperty(value = "License key list")


  public List<String> getLicenseKeyList() {
    return licenseKeyList;
  }

  public void setLicenseKeyList(List<String> licenseKeyList) {
    this.licenseKeyList = licenseKeyList;
  }

  public LicenseCategoryOtherIdsOpenApiVo selectAll(Boolean selectAll) {
    this.selectAll = selectAll;
    return this;
  }

  /**
   * Select all used license
   * @return selectAll
  */
  @ApiModelProperty(value = "Select all used license")


  public Boolean getSelectAll() {
    return selectAll;
  }

  public void setSelectAll(Boolean selectAll) {
    this.selectAll = selectAll;
  }

  public LicenseCategoryOtherIdsOpenApiVo total(Integer total) {
    this.total = total;
    return this;
  }

  /**
   * Total select used license
   * minimum: 0
   * @return total
  */
  @ApiModelProperty(value = "Total select used license")

@Min(0)
  public Integer getTotal() {
    return total;
  }

  public void setTotal(Integer total) {
    this.total = total;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    LicenseCategoryOtherIdsOpenApiVo licenseCategoryOtherIdsOpenApiVo = (LicenseCategoryOtherIdsOpenApiVo) o;
    return Objects.equals(this.licenseKeyList, licenseCategoryOtherIdsOpenApiVo.licenseKeyList) &&
        Objects.equals(this.selectAll, licenseCategoryOtherIdsOpenApiVo.selectAll) &&
        Objects.equals(this.total, licenseCategoryOtherIdsOpenApiVo.total);
  }

  @Override
  public int hashCode() {
    return Objects.hash(licenseKeyList, selectAll, total);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class LicenseCategoryOtherIdsOpenApiVo {\n");
    
    sb.append("    licenseKeyList: ").append(toIndentedString(licenseKeyList)).append("\n");
    sb.append("    selectAll: ").append(toIndentedString(selectAll)).append("\n");
    sb.append("    total: ").append(toIndentedString(total)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

